import greenfoot.*;

/**
 * Mover claas: gives actors smooth movement
 */
public class Mover extends Actor
{
    double vel, rot; // speed and direction
    double xPos, yPos; // location
    
    /**
     * addedToWorld method (override): gets initial location coordinates
     */
    protected void addedToWorld(World world)
    {
        xPos = getX();
        yPos = getY();
    }
    
    /**
     * move method: moves actor using speed (vel) and direction (rot) values
     */
    public void move()
    {
        xPos += Math.cos(Math.PI*rot/180d)*vel;
        yPos += Math.sin(Math.PI*rot/180d)*vel;
        setLocation((int)xPos, (int)yPos);
    }
    
    /**
     * addForce method:  adjusts speed and direction by given vector parts
     */
    public void addForce(double speed, double direction)
    {
        // convert vector parts to cartesian values
        double dx = Math.cos(Math.PI*rot/180d)*vel;
        double dy = Math.sin(Math.PI*rot/180d)*vel;
        // apply new vector parts after converting to cartesian values
        dx += Math.cos(Math.PI*direction/180d)*speed;
        dy += Math.sin(Math.PI*direction/180d)*speed;
        // convert back to vector parts (applying speed limit)
        vel = Math.hypot(dx, dy);
        if (vel > 2) vel = 2;
        rot = Math.atan2(dy, dx)*180d/Math.PI;
    }
}