import greenfoot.*;

public class Particle extends Mover
{
    public Particle()
    {
        // image
        GreenfootImage img = new GreenfootImage(6, 6);
        img.setColor(new Color(128+MyWorld.rand(128), 128+MyWorld.rand(128), 128+MyWorld.rand(128)));
        img.fillOval(0, 0, 6, 6);
        setImage(img);
        // initial field values
        vel = ((double)Greenfoot.getRandomNumber(30))/100d;
        rot = (double)Greenfoot.getRandomNumber(360);
    }
    
    /**
     * checkEdges method:  cancels speed toward an edge when that edge is hit
     */
    public void checkEdges()
    {
        if (rot > -90 && rot < 90 && getX() == getWorld().getWidth()-1) addForce(-Math.cos(Math.PI*rot/180d)*vel, 0);
        if (rot > 0 && rot < 180 && getY() == getWorld().getHeight()-1) addForce(-Math.sin(Math.PI*rot/180d)*vel, 90);
        if (rot < 0 && getY() == 0) addForce(-Math.sin(Math.PI*rot/180d)*vel, 90);
        if ((rot < -90 || rot > 90) && getX() == 0) addForce(-Math.cos(Math.PI*rot/180d)*vel, 0);
    }
    
    /**
     * act method: controls movement of particle
     */
    public void act()
    {
        move();
        checkEdges();
    }
}